classification
Title: Python with MinGW
Type: enhancement Stage: resolved
Components: Versions: Python 3.4
process
Status: closed Resolution: duplicate
Dependencies: Superseder: mingw-meta: build interpeter core
View: 17605
Assigned To: Nosy List: BreamoreBoy, Friedrich.Spee.von.Langenfeld, christian.heimes, eudoxos, loewis, r.david.murray, rpetrov
Priority: normal Keywords:

Created on 2013-07-07 20:02 by Friedrich.Spee.von.Langenfeld, last changed 2018-07-19 06:02 by martin.panter. This issue is now closed.

Files
File name Uploaded Description Edit
configure_test.txt Friedrich.Spee.von.Langenfeld, 2013-07-09 08:08
make_test.txt Friedrich.Spee.von.Langenfeld, 2013-07-09 08:49
Messages (11)
msg192585 - (view) Author: Friedrich Spee von Langenfeld (Friedrich.Spee.von.Langenfeld) Date: 2013-07-07 20:02
I think, there are some users which are going to compile Python, but disagree with the restriction of Visual Studio (use only with account after 90 days). Should we provide makefiles to compile Python with MinGW (this could be easily done with the "Export" function of Visual Studio, see http://oldwiki.mingw.org/index.php/ConvertVisualStudioWorkspace for Details)? Or should we provide a CMakeList.txt to give the user the ability to make his own makefiles?
msg192595 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2013-07-07 21:10
The bug tracker isn't the best place to discuss such matters. Please open a discussion on the python-ideas mailing list if you are interested in improving the situation.

Hint: New Windows developers are always welcome. We don't have that many... :)
msg192599 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2013-07-07 22:10
The best way would be if the standard Unix configure succeeded under MingW/msys. Did you actually try whether that worked?
msg192725 - (view) Author: Friedrich Spee von Langenfeld (Friedrich.Spee.von.Langenfeld) Date: 2013-07-09 08:08
@ Christian Heimes
Thank you for your hint. Martin v. Löwis made an interesting commend, if his way succeed, it would be worth considering to make a paragraph in the devguide how to build Python with MinGW. The way Forward depends on the results.

@ Martin v. Löwis
I've tried the Unix configure under MinGW. It failed.
I've written it in the appended file with:
$ cd C:/MinGW/python_mercurial
$ ./configure >& configure_test.txt
msg192726 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2013-07-09 08:19
Please install awk and try again.
msg192731 - (view) Author: Friedrich Spee von Langenfeld (Friedrich.Spee.von.Langenfeld) Date: 2013-07-09 08:49
I've installed the MSYS gawk Utility and configure succeeded (thank you!), but now make failed. Should I upload the entire log file or ony the error messages?
msg192755 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2013-07-09 14:29
I believe there are open (and some closed) issues in this tracker related to mingw support, though many of them are for support for compiling extensions using mingw, which is actually a harder problem.  They will probably provide clues if nothing else.  What we probably lack is a core developer with the time and desire to review and commit the patches.  If I remember correctly someone started trying to sort the proposals into small enough patches to make review practical.  With another pair of eyes doing review, testing, and sorting, the chances of making progress would be increased.
msg192759 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2013-07-09 15:27
@David: I don't think any of the other open issues actually addresses building Python with mingw (but I may misremember).

@Friedrich: This is only going to be productive if you are willing to look into the issues yourself, and propose changes. If I had time to look into this issue (which I don't), it would be much easier for me to reproduce and fix the problem, than to wait for you to report the next problem. Be prepared that this task may take several days (or even weeks) of work. If you merely keep reporting the problems you find, expect people to lose interest quickly.

As for the specific problem (make_test.txt): MS_WINDOWS needs to get defined somehow (I think), and then EALREADY etc ought to come from winsock2.h (see exceptions.c around line 2360).

Try replacing the generated pyconfig.h with PC/pyconfig.h to see whether that gets you further.
msg192762 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2013-07-09 16:19
@Martin: you are probably correct, though I think there was at least one closed issue that did deal with mingw/msys build.  As I recall it wasn't coherent enough to produce useful patches, but may have some clues.
msg193216 - (view) Author: Václav Šmilauer (eudoxos) * Date: 2013-07-17 09:23
@David & others: mingw build is covered in detail under issue17605 by Roumen Petrov.
msg223061 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2014-07-14 21:33
Nothing has been done with #17605 or the associated issues to my knowledge.  I've no idea as to whether or not the originator will be picking them up again or if he is open to another user picking them up.  I do know that there are 56 open issues with mingw in the title.
History
Date User Action Args
2018-07-19 06:02:41martin.pantersetstatus: open -> closed
superseder: mingw-meta: build interpeter core
resolution: duplicate
stage: resolved
2014-07-14 21:33:02BreamoreBoysetnosy: + BreamoreBoy
messages: + msg223061
2013-07-17 09:23:03eudoxossetnosy: + eudoxos
messages: + msg193216
2013-07-09 19:10:59rpetrovsetnosy: + rpetrov
2013-07-09 16:19:52r.david.murraysetmessages: + msg192762
2013-07-09 15:27:30loewissetmessages: + msg192759
2013-07-09 14:29:05r.david.murraysetnosy: + r.david.murray
messages: + msg192755
2013-07-09 08:49:26Friedrich.Spee.von.Langenfeldsetfiles: + make_test.txt

messages: + msg192731
2013-07-09 08:19:51christian.heimessetmessages: + msg192726
2013-07-09 08:08:46Friedrich.Spee.von.Langenfeldsetfiles: + configure_test.txt

messages: + msg192725
components: - Build, Windows
2013-07-07 22:10:01loewissetnosy: + loewis
messages: + msg192599
2013-07-07 21:10:37christian.heimessetversions: + Python 3.4
nosy: + christian.heimes

messages: + msg192595

components: + Windows
type: enhancement
2013-07-07 20:02:53Friedrich.Spee.von.Langenfeldcreate